package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WXAccessToken;
import com.sa.ibiz.demo.demo.service.WXAccessTokenService;
import com.sa.ibiz.demo.demo.service.dto.WXAccessTokenSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wxaccesstoken")
public class WXAccessTokenResource
{
	@Autowired
	private WXAccessTokenService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<WXAccessToken> checkKey(@Validated @RequestBody WXAccessToken data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("微信访问票据[checkKey]操作发生错误","WXAccessToken",data.getWxaccesstokenid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WXAccessToken> create(@Validated @RequestBody WXAccessToken data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("微信访问票据[create]操作发生错误","WXAccessToken",data.getWxaccesstokenid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WXAccessToken> remove(@Validated @RequestBody WXAccessToken data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("微信访问票据[remove]操作发生错误","WXAccessToken",data.getWxaccesstokenid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WXAccessToken> get(@Validated @PathVariable String id){
		WXAccessToken data=new WXAccessToken();
		data.setWxaccesstokenid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("微信访问票据[get]操作发生错误","WXAccessToken",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WXAccessToken> update(@Validated @RequestBody WXAccessToken data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("微信访问票据[update]操作发生错误","WXAccessToken",data.getWxaccesstokenid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WXAccessToken> getDraft(@Validated @RequestBody WXAccessToken data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("微信访问票据[getDraft]操作发生错误","WXAccessToken","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WXAccessToken>> searchDefaultPage(@Validated @RequestBody WXAccessTokenSearchFilter filter){
		Page<WXAccessToken> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WXAccessToken>> listDefault(@Validated @RequestBody WXAccessTokenSearchFilter filter){
		List<WXAccessToken> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
